Index: res/res_indications.c
===================================================================
RCS file: /usr/cvsroot/asterisk/res/res_indications.c,v
retrieving revision 1.5
diff -u -r1.5 res_indications.c
--- res/res_indications.c	11 Feb 2004 00:17:48 -0000	1.5
+++ res/res_indications.c	2 May 2004 03:18:52 -0000
@@ -184,17 +184,25 @@
 static int handle_playtones(struct ast_channel *chan, void *data)
 {
 	struct tone_zone_sound *ts;
-	int res;
+	int res, interrupt=0;
+	char *options;
 
 	if (!data || !((char*)data)[0]) {
 		ast_log(LOG_NOTICE,"Nothing to play\n");
 		return -1;
 	}
+	options = strchr(data, '|');
+	if (options) {
+		*options = '\0';
+		options++;
+		if (!strcasecmp(options, "i"))
+			interrupt = 1; 
+	}
 	ts = ast_get_indication_tone(chan->zone, (const char*)data);
 	if (ts && ts->data[0])
-		res = ast_playtones_start(chan, 0, ts->data, 0);
+		res = ast_playtones_start(chan, 0, ts->data, interrupt);
 	else
-		res = ast_playtones_start(chan, 0, (const char*)data, 0);
+		res = ast_playtones_start(chan, 0, (const char*)data, interrupt);
 	if (res)
 		ast_log(LOG_NOTICE,"Unable to start playtones\n");
 	return res;
@@ -380,7 +388,7 @@
 	ast_cli_register(&add_indication_cli);
 	ast_cli_register(&remove_indication_cli);
 	ast_cli_register(&show_indications_cli);
-	ast_register_application("Playtones", handle_playtones, "Play a tone list","Play a tone list, either registered (through indications.conf) or a direct list of tones and durations.");
+	ast_register_application("Playtones", handle_playtones, "Play a tone list","Playtones(tone[|i]):  Play a tone list, either registered\n(through indications.conf) or a direct list of tones and durations.\nThe option i may also be included following a pipe symbol;\nif i is specified the playback will be interrupted if a digit is entered.");
 	ast_register_application("StopPlaytones", handle_stopplaytones, "Stop playing a tone list","Stop playing a tone list");
 
 	return 0;
Index: pbx.c
===================================================================
RCS file: /usr/cvsroot/asterisk/pbx.c,v
retrieving revision 1.116
diff -u -r1.116 pbx.c
--- pbx.c	29 Apr 2004 02:30:14 -0000	1.116
+++ pbx.c	2 May 2004 03:18:58 -0000
@@ -1816,6 +1816,8 @@
 				/* As long as we're willing to wait, and as long as it's not defined, 
 				   keep reading digits until we can't possibly get a right answer anymore.  */
 				digit = ast_waitfordigit(c, waittime * 1000);
+				if (c->writeinterrupt)
+					ast_deactivate_generator(c);
 				if (c->_softhangup == AST_SOFTHANGUP_ASYNCGOTO) {
 					c->_softhangup = 0;
 				} else {
